/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         odl_parse
#define yylex           odl_lex
#define yyerror         odl_error
#define yydebug         odl_debug
#define yynerrs         odl_nerrs
#define yylval          odl_lval
#define yychar          odl_char

/* First part of user prologue.  */
#line 1 "gt_overlay_yac.y"

/**********************************************************************
 **                                                                  **
 **                         gt_overlay_yac.y                         **
 **                                                                  **
 **                                                                  **
 **        Parser for the overlay description language (odl)         **
 **                                                                  **
 **        See the MissionLab user's manual for details.             **
 **                                                                  **
 **                                                                  **
 **  Written by:  Jonathan M. Cameron                                **
 **                                                                  **
 **  Copyright 1995, 1996, 1997 Georgia Tech Research Corporation    **
 **  Atlanta, Georgia  30332-0415                                    **
 **  ALL RIGHTS RESERVED, See file COPYRIGHT for details.            **
 **                                                                  ** 
 **********************************************************************/

/* $Id: gt_overlay_yac.y,v 1.1.1.1 2008/07/14 16:44:22 endo Exp $ */

extern "C" {
#include <stdio.h>
#include <malloc.h>
#include <stdarg.h>
}

#include "gt_world.h"
#include "gt_scale.h"
#include "gt_measure.h"
#include "console.h"
#include "gt_console_db.h"
#include "3d_vis_wid.h"
#include "convert_scale.h"

extern int odl_lex();
extern void odl_error(char *);
extern void odl_errorf(const char *, ...);
int odl_parse();
double utmx, utmy;
int map_scale_factor = -1;

#line 121 "gt_overlay_yac.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "gt_overlay_yac.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_SCENARIO = 3,                   /* SCENARIO  */
  YYSYMBOL_SITE = 4,                       /* SITE  */
  YYSYMBOL_ORIGIN = 5,                     /* ORIGIN  */
  YYSYMBOL_GLOBAL_REF_POINT = 6,           /* GLOBAL_REF_POINT  */
  YYSYMBOL_MISSION_AREA = 7,               /* MISSION_AREA  */
  YYSYMBOL_LOAD_MAP = 8,                   /* LOAD_MAP  */
  YYSYMBOL_CONTROL_MEASURES = 9,           /* CONTROL_MEASURES  */
  YYSYMBOL_SET_TOKEN = 10,                 /* SET_TOKEN  */
  YYSYMBOL_ZOOM_FACTOR_TOKEN = 11,         /* ZOOM_FACTOR_TOKEN  */
  YYSYMBOL_ATTRACTOR_TOKEN = 12,           /* ATTRACTOR_TOKEN  */
  YYSYMBOL_BASKET_TOKEN = 13,              /* BASKET_TOKEN  */
  YYSYMBOL_AA_TOKEN = 14,                  /* AA_TOKEN  */
  YYSYMBOL_ATK_TOKEN = 15,                 /* ATK_TOKEN  */
  YYSYMBOL_AXIS_TOKEN = 16,                /* AXIS_TOKEN  */
  YYSYMBOL_BOUNDARY_TOKEN = 17,            /* BOUNDARY_TOKEN  */
  YYSYMBOL_BP_TOKEN = 18,                  /* BP_TOKEN  */
  YYSYMBOL_GAP_TOKEN = 19,                 /* GAP_TOKEN  */
  YYSYMBOL_LDLC_TOKEN = 20,                /* LDLC_TOKEN  */
  YYSYMBOL_OBJ_TOKEN = 21,                 /* OBJ_TOKEN  */
  YYSYMBOL_OBSTACLE_TOKEN = 22,            /* OBSTACLE_TOKEN  */
  YYSYMBOL_PL_TOKEN = 23,                  /* PL_TOKEN  */
  YYSYMBOL_PP_TOKEN = 24,                  /* PP_TOKEN  */
  YYSYMBOL_SP_TOKEN = 25,                  /* SP_TOKEN  */
  YYSYMBOL_UTM_TOKEN = 26,                 /* UTM_TOKEN  */
  YYSYMBOL_LAT_TOKEN = 27,                 /* LAT_TOKEN  */
  YYSYMBOL_LON_TOKEN = 28,                 /* LON_TOKEN  */
  YYSYMBOL_WALL_TOKEN = 29,                /* WALL_TOKEN  */
  YYSYMBOL_ROOM_TOKEN = 30,                /* ROOM_TOKEN  */
  YYSYMBOL_DOOR_TOKEN = 31,                /* DOOR_TOKEN  */
  YYSYMBOL_HALLWAY_TOKEN = 32,             /* HALLWAY_TOKEN  */
  YYSYMBOL_CENTERLINE_TOKEN = 33,          /* CENTERLINE_TOKEN  */
  YYSYMBOL_WIDTH_TOKEN = 34,               /* WIDTH_TOKEN  */
  YYSYMBOL_EXTENTS_TOKEN = 35,             /* EXTENTS_TOKEN  */
  YYSYMBOL_HEADING = 36,                   /* HEADING  */
  YYSYMBOL_WAYPOINT_FILE_TOKEN = 37,       /* WAYPOINT_FILE_TOKEN  */
  YYSYMBOL_SCALE_TOKEN = 38,               /* SCALE_TOKEN  */
  YYSYMBOL_HEIGHTMAP = 39,                 /* HEIGHTMAP  */
  YYSYMBOL_QSTRING = 40,                   /* QSTRING  */
  YYSYMBOL_IDENTIFIER = 41,                /* IDENTIFIER  */
  YYSYMBOL_FILENAME = 42,                  /* FILENAME  */
  YYSYMBOL_NUMBER = 43,                    /* NUMBER  */
  YYSYMBOL_OBJECT_TOKEN = 44,              /* OBJECT_TOKEN  */
  YYSYMBOL_OBJ_STYLE = 45,                 /* OBJ_STYLE  */
  YYSYMBOL_YYACCEPT = 46,                  /* $accept  */
  YYSYMBOL_file = 47,                      /* file  */
  YYSYMBOL_info_part = 48,                 /* info_part  */
  YYSYMBOL_info_statement = 49,            /* info_statement  */
  YYSYMBOL_scenario_statement = 50,        /* scenario_statement  */
  YYSYMBOL_site_statement = 51,            /* site_statement  */
  YYSYMBOL_origin_statement = 52,          /* origin_statement  */
  YYSYMBOL_global_ref_pt_statement = 53,   /* global_ref_pt_statement  */
  YYSYMBOL_heading_statement = 54,         /* heading_statement  */
  YYSYMBOL_load_map_statement = 55,        /* load_map_statement  */
  YYSYMBOL_heightmap_statement = 56,       /* heightmap_statement  */
  YYSYMBOL_scale_statement = 57,           /* scale_statement  */
  YYSYMBOL_mission_area_statement = 58,    /* mission_area_statement  */
  YYSYMBOL_set_zoom_factor_statement = 59, /* set_zoom_factor_statement  */
  YYSYMBOL_control_measure_part = 60,      /* control_measure_part  */
  YYSYMBOL_control_measure_list = 61,      /* control_measure_list  */
  YYSYMBOL_control_measure_statement = 62, /* control_measure_statement  */
  YYSYMBOL_assembly_area_statement = 63,   /* assembly_area_statement  */
  YYSYMBOL_attack_position_statement = 64, /* attack_position_statement  */
  YYSYMBOL_axis_statement = 65,            /* axis_statement  */
  YYSYMBOL_battle_position_statement = 66, /* battle_position_statement  */
  YYSYMBOL_boundary_statement = 67,        /* boundary_statement  */
  YYSYMBOL_gap_statement = 68,             /* gap_statement  */
  YYSYMBOL_ldlc_statement = 69,            /* ldlc_statement  */
  YYSYMBOL_objective_statement = 70,       /* objective_statement  */
  YYSYMBOL_obstacle_statement = 71,        /* obstacle_statement  */
  YYSYMBOL_passage_point_statement = 72,   /* passage_point_statement  */
  YYSYMBOL_basket_statement = 73,          /* basket_statement  */
  YYSYMBOL_attractor_statement = 74,       /* attractor_statement  */
  YYSYMBOL_object_statement = 75,          /* object_statement  */
  YYSYMBOL_phase_line_statement = 76,      /* phase_line_statement  */
  YYSYMBOL_starting_point_statement = 77,  /* starting_point_statement  */
  YYSYMBOL_wall_statement = 78,            /* wall_statement  */
  YYSYMBOL_room_statement = 79,            /* room_statement  */
  YYSYMBOL_door_statement = 80,            /* door_statement  */
  YYSYMBOL_hallway_statement = 81,         /* hallway_statement  */
  YYSYMBOL_waypoint_file_statement = 82,   /* waypoint_file_statement  */
  YYSYMBOL_coordinate_list = 83,           /* coordinate_list  */
  YYSYMBOL_coordinate_pair = 84,           /* coordinate_pair  */
  YYSYMBOL_utm_coordinate = 85,            /* utm_coordinate  */
  YYSYMBOL_name = 86                       /* name  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  38
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   163

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  46
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  41
/* YYNRULES -- Number of rules.  */
#define YYNRULES  88
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  163

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   300


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    70,    70,    75,    76,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    92,   102,   112,   117,   125,
     133,   137,   147,   156,   167,   188,   199,   203,   204,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   234,
     241,   251,   258,   268,   275,   285,   292,   302,   312,   320,
     331,   341,   348,   358,   366,   377,   384,   394,   401,   412,
     419,   428,   435,   446,   457,   468,   476,   485,   494,   504,
     514,   524,   526,   538,   551,   565,   570,   577,   578
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "SCENARIO", "SITE",
  "ORIGIN", "GLOBAL_REF_POINT", "MISSION_AREA", "LOAD_MAP",
  "CONTROL_MEASURES", "SET_TOKEN", "ZOOM_FACTOR_TOKEN", "ATTRACTOR_TOKEN",
  "BASKET_TOKEN", "AA_TOKEN", "ATK_TOKEN", "AXIS_TOKEN", "BOUNDARY_TOKEN",
  "BP_TOKEN", "GAP_TOKEN", "LDLC_TOKEN", "OBJ_TOKEN", "OBSTACLE_TOKEN",
  "PL_TOKEN", "PP_TOKEN", "SP_TOKEN", "UTM_TOKEN", "LAT_TOKEN",
  "LON_TOKEN", "WALL_TOKEN", "ROOM_TOKEN", "DOOR_TOKEN", "HALLWAY_TOKEN",
  "CENTERLINE_TOKEN", "WIDTH_TOKEN", "EXTENTS_TOKEN", "HEADING",
  "WAYPOINT_FILE_TOKEN", "SCALE_TOKEN", "HEIGHTMAP", "QSTRING",
  "IDENTIFIER", "FILENAME", "NUMBER", "OBJECT_TOKEN", "OBJ_STYLE",
  "$accept", "file", "info_part", "info_statement", "scenario_statement",
  "site_statement", "origin_statement", "global_ref_pt_statement",
  "heading_statement", "load_map_statement", "heightmap_statement",
  "scale_statement", "mission_area_statement", "set_zoom_factor_statement",
  "control_measure_part", "control_measure_list",
  "control_measure_statement", "assembly_area_statement",
  "attack_position_statement", "axis_statement",
  "battle_position_statement", "boundary_statement", "gap_statement",
  "ldlc_statement", "objective_statement", "obstacle_statement",
  "passage_point_statement", "basket_statement", "attractor_statement",
  "object_statement", "phase_line_statement", "starting_point_statement",
  "wall_statement", "room_statement", "door_statement",
  "hallway_statement", "waypoint_file_statement", "coordinate_list",
  "coordinate_pair", "utm_coordinate", "name", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-79)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
       8,    22,    22,     5,   -26,   -23,    22,    19,   -18,     0,
      10,    42,    -1,   -79,   -79,   -79,   -79,   -79,   -79,   -79,
     -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,    44,    12,
     -79,    21,    30,   -79,    32,   -79,   -79,    47,   -79,   119,
     -79,   -79,    48,    49,   -79,   -79,   -79,   -79,    50,    13,
      13,    22,    22,    22,    22,    22,    22,    22,    22,    13,
      22,    22,    22,    22,    22,    22,    22,    22,    13,   119,
     -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,
     -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,
     -79,    66,    68,    53,    54,    55,   -79,    56,    13,    13,
      13,    13,    13,    13,    13,    13,    57,    13,    13,    13,
      13,    13,    13,    69,   -79,    58,   -79,    60,    61,    64,
     -79,   -79,   -79,    14,   -79,    15,    23,    13,    24,    13,
      13,    25,    65,    13,    67,   -79,    27,    13,    13,    13,
      77,   -79,   -79,   -79,    54,   -79,    54,    54,    54,   102,
      54,   -79,   -79,    54,     2,    45,   -79,   103,   -79,   -79,
      71,    13,    13
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     3,     5,     6,     7,     8,     9,    10,
      11,    14,    12,    13,    88,    87,    15,    16,     0,     0,
      18,     0,     0,    21,     0,    20,    23,     0,     1,     0,
       4,     2,     0,     0,    17,    19,    24,    25,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    26,
      27,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    41,    39,    40,    42,    43,    44,    45,    46,    47,
      48,     0,     0,     0,     0,    69,    84,    67,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    80,     0,    28,     0,     0,     0,
      83,    70,    68,    49,    81,    51,    53,    57,    55,     0,
      60,    61,    63,    73,    65,    74,    75,    77,    78,     0,
       0,    85,    86,    22,    50,    82,    52,    54,    56,    58,
      62,    64,    66,    76,     0,     0,    59,     0,    72,    71,
       0,     0,    79
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -79,   -79,   -79,    97,   -79,   -79,   -79,   -79,   -79,   -79,
     -79,   -79,   -79,   -79,   -79,   -79,    43,   -79,   -79,   -79,
     -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,
     -79,   -79,   -79,   -79,   -79,   -79,   -79,   -78,   -49,   108,
      63
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    41,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,   123,   124,    96,
      26
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      95,    97,     1,     2,     3,     4,     5,     6,    39,     7,
     106,     1,     2,     3,     4,     5,     6,    31,     7,   115,
      32,   125,   126,   127,   128,    35,   130,   131,    28,   133,
      34,    28,   136,   137,   138,     8,   157,     9,    10,    28,
      28,    28,    38,    36,     8,    94,     9,    10,    29,    28,
      28,    28,    37,    28,   129,    44,    94,   144,   146,   134,
     135,   154,    24,    25,    45,    27,   147,   148,   150,    33,
     153,    42,    43,    46,   145,    47,   145,   145,   145,   145,
     149,   145,   145,   162,   145,   158,   159,   145,   145,   145,
      48,    91,    92,    93,   117,   118,   119,   120,   121,   122,
     132,   140,   139,   141,   142,   145,   161,   143,   151,    40,
     152,    30,   116,   145,    98,    99,   100,   101,   102,   103,
     104,   105,   155,   107,   108,   109,   110,   111,   112,   113,
     114,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,   156,   160,     0,    63,    64,
      65,    66,     0,     0,     0,     0,    67,     0,     0,     0,
       0,     0,     0,    68
};

static const yytype_int16 yycheck[] =
{
      49,    50,     3,     4,     5,     6,     7,     8,     9,    10,
      59,     3,     4,     5,     6,     7,     8,    43,    10,    68,
      43,    99,   100,   101,   102,    43,   104,   105,    26,   107,
      11,    26,   110,   111,   112,    36,    34,    38,    39,    26,
      26,    26,     0,    43,    36,    43,    38,    39,    43,    26,
      26,    26,    42,    26,   103,    43,    43,    43,    43,   108,
     109,   139,    40,    41,    43,     2,    43,    43,    43,     6,
      43,    27,    28,    43,   123,    43,   125,   126,   127,   128,
     129,   130,   131,   161,   133,    40,    41,   136,   137,   138,
      43,    43,    43,    43,    28,    27,    43,    43,    43,    43,
      43,    43,    33,    43,    43,   154,    35,    43,    43,    12,
      43,     3,    69,   162,    51,    52,    53,    54,    55,    56,
      57,    58,    45,    60,    61,    62,    63,    64,    65,    66,
      67,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    43,    43,    -1,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    -1,    44
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,    10,    36,    38,
      39,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    40,    41,    86,    86,    26,    43,
      85,    43,    43,    86,    11,    43,    43,    42,     0,     9,
      49,    60,    27,    28,    43,    43,    43,    43,    43,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    29,    30,    31,    32,    37,    44,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    43,    43,    43,    43,    84,    85,    84,    86,    86,
      86,    86,    86,    86,    86,    86,    84,    86,    86,    86,
      86,    86,    86,    86,    86,    84,    62,    28,    27,    43,
      43,    43,    43,    83,    84,    83,    83,    83,    83,    84,
      83,    83,    43,    83,    84,    84,    83,    83,    83,    33,
      43,    43,    43,    43,    43,    84,    43,    43,    43,    84,
      43,    43,    43,    43,    83,    45,    43,    34,    40,    41,
      43,    35,    83
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    46,    47,    48,    48,    49,    49,    49,    49,    49,
      49,    49,    49,    49,    49,    50,    51,    52,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    61,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    63,
      63,    64,    64,    65,    65,    66,    66,    67,    68,    68,
      69,    70,    70,    71,    71,    72,    72,    73,    73,    74,
      74,    75,    75,    76,    77,    78,    78,    79,    80,    81,
      82,    83,    83,    84,    84,    85,    85,    86,    86
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     3,     2,     3,
       2,     2,     6,     2,     3,     3,     2,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       4,     3,     4,     3,     4,     3,     4,     3,     4,     5,
       3,     3,     4,     3,     4,     3,     4,     2,     3,     2,
       3,     5,     5,     3,     3,     3,     4,     3,     3,     8,
       2,     1,     2,     2,     1,     5,     5,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 15: /* scenario_statement: SCENARIO name  */
#line 93 "gt_overlay_yac.y"
                {
		   if(gt_add_scenario_label((yyvsp[0].strval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add SCENARIO %s", (yyvsp[0].strval));
		      YYABORT;
		      }
		}
#line 1324 "gt_overlay_yac.c"
    break;

  case 16: /* site_statement: SITE name  */
#line 103 "gt_overlay_yac.y"
                {
		   if (gt_add_site_name((yyvsp[0].strval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add SITE %s", (yyvsp[0].strval));
		      YYABORT;
		      }
		}
#line 1335 "gt_overlay_yac.c"
    break;

  case 17: /* origin_statement: ORIGIN NUMBER NUMBER  */
#line 113 "gt_overlay_yac.y"
                {
		   origin_x = (yyvsp[-1].fval);
		   origin_y = (yyvsp[0].fval);
		}
#line 1344 "gt_overlay_yac.c"
    break;

  case 18: /* origin_statement: ORIGIN utm_coordinate  */
#line 118 "gt_overlay_yac.y"
                {
		  origin_x = (yyvsp[0].utm_coord)[0];
		  origin_y = (yyvsp[0].utm_coord)[1];
		}
#line 1353 "gt_overlay_yac.c"
    break;

  case 19: /* global_ref_pt_statement: GLOBAL_REF_POINT NUMBER NUMBER  */
#line 126 "gt_overlay_yac.y"
               {
		 g_ref_latitude = (yyvsp[-1].fval);
		 g_ref_longitude = (yyvsp[0].fval);
	       }
#line 1362 "gt_overlay_yac.c"
    break;

  case 20: /* heading_statement: HEADING NUMBER  */
#line 133 "gt_overlay_yac.y"
                          {origin_heading = (yyvsp[0].fval);}
#line 1368 "gt_overlay_yac.c"
    break;

  case 21: /* load_map_statement: LOAD_MAP name  */
#line 138 "gt_overlay_yac.y"
                {
		   if (!load_map(gMapInfo, (yyvsp[0].strval), drawing_area)) {
		      odl_errorf("Error: Unable to LOAD-MAP %s", (yyvsp[0].strval));
		      YYABORT;
		      }
		}
#line 1379 "gt_overlay_yac.c"
    break;

  case 22: /* heightmap_statement: HEIGHTMAP FILENAME NUMBER NUMBER NUMBER NUMBER  */
#line 148 "gt_overlay_yac.y"
{ printf("Loading a height map: %s %d %d %d %d\n", (yyvsp[-4].strval), (int)(yyvsp[-3].fval), (int)(yyvsp[-2].fval), (int)(yyvsp[-1].fval), (int)(yyvsp[0].fval));
  if (!load_heightmap((yyvsp[-4].strval), (int)(yyvsp[-3].fval), (int)(yyvsp[-2].fval), (int)(yyvsp[-1].fval), (int)(yyvsp[0].fval))) {
  odl_errorf("Error: Unable to load a height map %s", (yyvsp[-4].strval));
  YYABORT;
}
}
#line 1390 "gt_overlay_yac.c"
    break;

  case 23: /* scale_statement: SCALE_TOKEN NUMBER  */
#line 157 "gt_overlay_yac.y"
{
	printf("Setting scale to: %d\n", (int)(yyvsp[0].fval));
	map_scale_factor = (int)(yyvsp[0].fval);
	set_meters_per_pixel(map_scale_factor / pixelsPerMeter);
	set_zoom_factor(1.0);
}
#line 1401 "gt_overlay_yac.c"
    break;

  case 24: /* mission_area_statement: MISSION_AREA NUMBER NUMBER  */
#line 168 "gt_overlay_yac.y"
                {
		   if ((yyvsp[-1].fval) < 0.0) {
		      odl_errorf("Mission-Area width must be positive (%1.8g)", (yyvsp[-1].fval));
		      YYABORT;
		      }
		   else if ((yyvsp[0].fval) < 0.0) {
		      odl_errorf("Mission-Area height must be positive (%1.8g)", (yyvsp[0].fval));
		      YYABORT;
		      }
		   else {
		      // The two lines below added by Nadeem to 
		      // use the same MISSION-AREA for lat/lon computations
		      map_width = (yyvsp[-1].fval); 
		      map_height = (yyvsp[0].fval);
		      set_mission_area_size((yyvsp[-1].fval), (yyvsp[0].fval));
		      }
		}
#line 1423 "gt_overlay_yac.c"
    break;

  case 25: /* set_zoom_factor_statement: SET_TOKEN ZOOM_FACTOR_TOKEN NUMBER  */
#line 189 "gt_overlay_yac.y"
                {
		   if (!set_zoom_factor((double)(yyvsp[0].fval)/100.0)) {
		      odl_errorf("Error setting zoom factor (%1.8g)", (yyvsp[0].fval));
		      YYABORT;
		      }
		}
#line 1434 "gt_overlay_yac.c"
    break;

  case 49: /* assembly_area_statement: AA_TOKEN name coordinate_list  */
#line 235 "gt_overlay_yac.y"
                { 
		   if(gt_add_assembly_area((yyvsp[-1].strval), (yyvsp[0].coords), -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Assembly Area %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1445 "gt_overlay_yac.c"
    break;

  case 50: /* assembly_area_statement: AA_TOKEN name coordinate_list NUMBER  */
#line 242 "gt_overlay_yac.y"
                { 
		   if(gt_add_assembly_area((yyvsp[-2].strval), (yyvsp[-1].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Assembly Area %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1456 "gt_overlay_yac.c"
    break;

  case 51: /* attack_position_statement: ATK_TOKEN name coordinate_list  */
#line 252 "gt_overlay_yac.y"
                {
		   if(gt_add_attack_position((yyvsp[-1].strval), (yyvsp[0].coords), -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Attack Point %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1467 "gt_overlay_yac.c"
    break;

  case 52: /* attack_position_statement: ATK_TOKEN name coordinate_list NUMBER  */
#line 259 "gt_overlay_yac.y"
                { 
		   if(gt_add_attack_position((yyvsp[-2].strval), (yyvsp[-1].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Attack Point %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1478 "gt_overlay_yac.c"
    break;

  case 53: /* axis_statement: AXIS_TOKEN name coordinate_list  */
#line 269 "gt_overlay_yac.y"
                {
		   if (gt_add_axis((yyvsp[-1].strval), (yyvsp[0].coords), -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Axis %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1489 "gt_overlay_yac.c"
    break;

  case 54: /* axis_statement: AXIS_TOKEN name coordinate_list NUMBER  */
#line 276 "gt_overlay_yac.y"
                {
		   if (gt_add_axis((yyvsp[-2].strval), (yyvsp[-1].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Axis %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1500 "gt_overlay_yac.c"
    break;

  case 55: /* battle_position_statement: BP_TOKEN name coordinate_list  */
#line 286 "gt_overlay_yac.y"
                {
		   if (gt_add_battle_position((yyvsp[-1].strval), (yyvsp[0].coords), -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Battle Position %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1511 "gt_overlay_yac.c"
    break;

  case 56: /* battle_position_statement: BP_TOKEN name coordinate_list NUMBER  */
#line 293 "gt_overlay_yac.y"
                {
		   if (gt_add_battle_position((yyvsp[-2].strval), (yyvsp[-1].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Battle Position %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1522 "gt_overlay_yac.c"
    break;

  case 57: /* boundary_statement: BOUNDARY_TOKEN name coordinate_list  */
#line 303 "gt_overlay_yac.y"
                {
		   if (gt_add_boundary((yyvsp[-1].strval), (yyvsp[0].coords)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Boundary %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1533 "gt_overlay_yac.c"
    break;

  case 58: /* gap_statement: GAP_TOKEN name coordinate_pair coordinate_pair  */
#line 313 "gt_overlay_yac.y"
                { 
		   (yyvsp[-1].coords)->next = (yyvsp[0].coords);
		   if (gt_add_gap((yyvsp[-2].strval), (yyvsp[-1].coords), -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Gap %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1545 "gt_overlay_yac.c"
    break;

  case 59: /* gap_statement: GAP_TOKEN name coordinate_pair coordinate_pair NUMBER  */
#line 321 "gt_overlay_yac.y"
                {
		   (yyvsp[-2].coords)->next = (yyvsp[-1].coords);
		   if (gt_add_gap((yyvsp[-3].strval), (yyvsp[-2].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Gap %s", (yyvsp[-3].strval));
		      YYABORT;
		      }
		}
#line 1557 "gt_overlay_yac.c"
    break;

  case 60: /* ldlc_statement: LDLC_TOKEN name coordinate_list  */
#line 332 "gt_overlay_yac.y"
                {
		   if (gt_add_ldlc((yyvsp[-1].strval), (yyvsp[0].coords)) != GT_SUCCESS) {
		      odl_errorf("Unable to add LD/LC %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1568 "gt_overlay_yac.c"
    break;

  case 61: /* objective_statement: OBJ_TOKEN name coordinate_list  */
#line 342 "gt_overlay_yac.y"
                {
		   if (gt_add_objective((yyvsp[-1].strval), (yyvsp[0].coords), -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Objective %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1579 "gt_overlay_yac.c"
    break;

  case 62: /* objective_statement: OBJ_TOKEN name coordinate_list NUMBER  */
#line 349 "gt_overlay_yac.y"
                {
		   if (gt_add_objective((yyvsp[-2].strval), (yyvsp[-1].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Objective %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1590 "gt_overlay_yac.c"
    break;

  case 63: /* obstacle_statement: OBSTACLE_TOKEN coordinate_pair NUMBER  */
#line 359 "gt_overlay_yac.y"
                {
		   if (gt_add_obstacle((yyvsp[-1].coords)->x, (yyvsp[-1].coords)->y, (yyvsp[0].fval)) !=  GT_SUCCESS) {
		      odl_errorf("Unable to add Obstacle (x=%1.9g, y=%1.9g, r=%1.9g)", 
				 (yyvsp[-1].coords)->x, (yyvsp[-1].coords)->y, (yyvsp[0].fval));
		      YYABORT;
		      }
		}
#line 1602 "gt_overlay_yac.c"
    break;

  case 64: /* obstacle_statement: OBSTACLE_TOKEN coordinate_pair NUMBER NUMBER  */
#line 367 "gt_overlay_yac.y"
               {
		 if (gt_add_obstacle((yyvsp[-2].coords)->x, (yyvsp[-2].coords)->y, (yyvsp[-1].fval), (yyvsp[0].fval)) !=  GT_SUCCESS) {
		   odl_errorf("Unable to add Obstacle (x=%1.9g, y=%1.9g, r=%1.9g, height = %1.9g)", 
			      (yyvsp[-2].coords)->x, (yyvsp[-2].coords)->y, (yyvsp[-1].fval), (yyvsp[0].fval));
		   YYABORT;
		 }
               }
#line 1614 "gt_overlay_yac.c"
    break;

  case 65: /* passage_point_statement: PP_TOKEN name coordinate_pair  */
#line 378 "gt_overlay_yac.y"
                {  
		   if(gt_add_passage_point((yyvsp[-1].strval), (yyvsp[0].coords)->x, (yyvsp[0].coords)->y, -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Passage Point %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1625 "gt_overlay_yac.c"
    break;

  case 66: /* passage_point_statement: PP_TOKEN name coordinate_pair NUMBER  */
#line 385 "gt_overlay_yac.y"
                { 
		   if(gt_add_passage_point((yyvsp[-2].strval), (yyvsp[-1].coords)->x, (yyvsp[-1].coords)->y, (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Passage Point %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1636 "gt_overlay_yac.c"
    break;

  case 67: /* basket_statement: BASKET_TOKEN coordinate_pair  */
#line 395 "gt_overlay_yac.y"
                {  
		   if(gt_add_basket((yyvsp[0].coords)->x, (yyvsp[0].coords)->y, -1) != GT_SUCCESS) {
		      odl_errorf("Unable to add Basket");
		      YYABORT;
		      }
		}
#line 1647 "gt_overlay_yac.c"
    break;

  case 68: /* basket_statement: BASKET_TOKEN coordinate_pair NUMBER  */
#line 402 "gt_overlay_yac.y"
                {  
		   if(gt_add_basket((yyvsp[-1].coords)->x, (yyvsp[-1].coords)->y, (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Basket");
		      YYABORT;
		      }
		}
#line 1658 "gt_overlay_yac.c"
    break;

  case 69: /* attractor_statement: ATTRACTOR_TOKEN coordinate_pair  */
#line 413 "gt_overlay_yac.y"
                {  
		   if(gt_add_attractor((yyvsp[0].coords)->x, (yyvsp[0].coords)->y, -1) != GT_SUCCESS) {
		      odl_errorf("Unable to add Attractor");
		      YYABORT;
		      }
		}
#line 1669 "gt_overlay_yac.c"
    break;

  case 70: /* attractor_statement: ATTRACTOR_TOKEN coordinate_pair NUMBER  */
#line 420 "gt_overlay_yac.y"
                {  
		   if(gt_add_attractor((yyvsp[-1].coords)->x, (yyvsp[-1].coords)->y, (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Attractor");
		      YYABORT;
		      }
		}
#line 1680 "gt_overlay_yac.c"
    break;

  case 71: /* object_statement: OBJECT_TOKEN coordinate_pair NUMBER OBJ_STYLE IDENTIFIER  */
#line 428 "gt_overlay_yac.y"
                                                                           {  
      if(gt_add_object((yyvsp[-3].coords)->x, (yyvsp[-3].coords)->y, (yyvsp[-2].fval), (yyvsp[0].strval), (yyvsp[-1].style)) != GT_SUCCESS) 
      {
         odl_errorf("Unable to create object");
	 YYABORT;
      }
   }
#line 1692 "gt_overlay_yac.c"
    break;

  case 72: /* object_statement: OBJECT_TOKEN coordinate_pair NUMBER OBJ_STYLE QSTRING  */
#line 435 "gt_overlay_yac.y"
                                                                        {  
      if(gt_add_object((yyvsp[-3].coords)->x, (yyvsp[-3].coords)->y, (yyvsp[-2].fval), (yyvsp[0].strval), (yyvsp[-1].style)) != GT_SUCCESS) 
      {
         odl_errorf("Unable to create object");
	 YYABORT;
      }
   }
#line 1704 "gt_overlay_yac.c"
    break;

  case 73: /* phase_line_statement: PL_TOKEN name coordinate_list  */
#line 447 "gt_overlay_yac.y"
                {
		   if (gt_add_phase_line((yyvsp[-1].strval), (yyvsp[0].coords)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Phase Line %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1715 "gt_overlay_yac.c"
    break;

  case 74: /* starting_point_statement: SP_TOKEN name coordinate_pair  */
#line 458 "gt_overlay_yac.y"
                { 
		   if (gt_add_starting_point((yyvsp[-1].strval), (yyvsp[0].coords)->x, (yyvsp[0].coords)->y) != GT_SUCCESS) {
		      odl_errorf("Unable to add Starting Point %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1726 "gt_overlay_yac.c"
    break;

  case 75: /* wall_statement: WALL_TOKEN name coordinate_list  */
#line 469 "gt_overlay_yac.y"
              {
		if (gt_add_wall((yyvsp[-1].strval), (yyvsp[0].coords)) != GT_SUCCESS) {
		  odl_errorf("Unable to add Wall %s", (yyvsp[-1].strval));
		  YYABORT;
		}
	      }
#line 1737 "gt_overlay_yac.c"
    break;

  case 76: /* wall_statement: WALL_TOKEN name coordinate_list NUMBER  */
#line 477 "gt_overlay_yac.y"
              {
		if (gt_add_wall((yyvsp[-2].strval), (yyvsp[-1].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		  odl_errorf("Unable to add Wall %s", (yyvsp[-2].strval));
		  YYABORT;
		}
	      }
#line 1748 "gt_overlay_yac.c"
    break;

  case 77: /* room_statement: ROOM_TOKEN name coordinate_list  */
#line 486 "gt_overlay_yac.y"
              {
		if (gt_add_room((yyvsp[-1].strval), (yyvsp[0].coords)) != GT_SUCCESS) {
		  odl_errorf("Unable to add Room %s", (yyvsp[-1].strval));
		  YYABORT;
		}
	      }
#line 1759 "gt_overlay_yac.c"
    break;

  case 78: /* door_statement: DOOR_TOKEN name coordinate_list  */
#line 495 "gt_overlay_yac.y"
              {
		if (gt_add_door((yyvsp[-1].strval), (yyvsp[0].coords)) != GT_SUCCESS) {
		  odl_errorf("Unable to add Door %s", (yyvsp[-1].strval));
		  YYABORT;
		}
	      }
#line 1770 "gt_overlay_yac.c"
    break;

  case 79: /* hallway_statement: HALLWAY_TOKEN name CENTERLINE_TOKEN coordinate_list WIDTH_TOKEN NUMBER EXTENTS_TOKEN coordinate_list  */
#line 505 "gt_overlay_yac.y"
              {
		if (gt_add_hallway((yyvsp[-6].strval), (yyvsp[-4].coords), (yyvsp[-2].fval), (yyvsp[0].coords)) != GT_SUCCESS) {
		  odl_errorf("Unable to add Hallway %s", (yyvsp[-6].strval));
		  YYABORT;
		}
	      }
#line 1781 "gt_overlay_yac.c"
    break;

  case 80: /* waypoint_file_statement: WAYPOINT_FILE_TOKEN name  */
#line 515 "gt_overlay_yac.y"
              {
		if (gt_load_waypoint_file((yyvsp[0].strval)) != GT_SUCCESS)
		{
		  /* Keep parsing even if the file is not loaded. */
		}
	      }
#line 1792 "gt_overlay_yac.c"
    break;

  case 81: /* coordinate_list: coordinate_pair  */
#line 525 "gt_overlay_yac.y"
                {  (yyval.coords) = (yyvsp[0].coords); }
#line 1798 "gt_overlay_yac.c"
    break;

  case 82: /* coordinate_list: coordinate_list coordinate_pair  */
#line 527 "gt_overlay_yac.y"
                {
		   gt_Point_list *pt = (yyvsp[-1].coords);
		   while (pt->next)
		      pt = pt->next;
		   pt->next = (yyvsp[0].coords);
		   (yyval.coords) = (yyvsp[-1].coords);
		}
#line 1810 "gt_overlay_yac.c"
    break;

  case 83: /* coordinate_pair: NUMBER NUMBER  */
#line 539 "gt_overlay_yac.y"
   { 
     if (((yyval.coords) = (gt_Point_list *)malloc(sizeof(gt_Point_list))) == NULL) {
       fprintf(stderr, "Ran out of memory creating coordinate pair (%f %f)",
	       (yyvsp[-1].fval), (yyvsp[0].fval));
       odl_errorf("Ran out of memory creating coordinate pair (%f %f)",
		  (yyvsp[-1].fval), (yyvsp[0].fval));
       YYABORT;
     }
     (yyval.coords)->x = (yyvsp[-1].fval) + origin_x;
     (yyval.coords)->y = (yyvsp[0].fval) + origin_y;
     (yyval.coords)->next = 0;
   }
#line 1827 "gt_overlay_yac.c"
    break;

  case 84: /* coordinate_pair: utm_coordinate  */
#line 551 "gt_overlay_yac.y"
                    {
     if (((yyval.coords) = (gt_Point_list *)malloc(sizeof(gt_Point_list))) == NULL) {
       fprintf(stderr, "Ran out of memory creating coordinate pair");
       odl_errorf("Ran out of memory creating coordinate pair");
       YYABORT;
     }
     
     (yyval.coords)->x = (yyvsp[0].utm_coord)[0] - origin_x;
     (yyval.coords)->y = (yyvsp[0].utm_coord)[1] - origin_y;
     (yyval.coords)->next = 0;
   }
#line 1843 "gt_overlay_yac.c"
    break;

  case 85: /* utm_coordinate: UTM_TOKEN LAT_TOKEN NUMBER LON_TOKEN NUMBER  */
#line 565 "gt_overlay_yac.y"
                                               {
     gt_convert_latlon_to_utm((yyvsp[-2].fval), (yyvsp[0].fval), &utmx, &utmy);
     (yyval.utm_coord)[0] = utmx;
     (yyval.utm_coord)[1] = utmy;
   }
#line 1853 "gt_overlay_yac.c"
    break;

  case 86: /* utm_coordinate: UTM_TOKEN LON_TOKEN NUMBER LAT_TOKEN NUMBER  */
#line 570 "gt_overlay_yac.y"
                                                 {
     gt_convert_latlon_to_utm((yyvsp[0].fval), (yyvsp[-2].fval), &utmx, &utmy);
     (yyval.utm_coord)[0] = utmx;
     (yyval.utm_coord)[1] = utmy;
   }
#line 1863 "gt_overlay_yac.c"
    break;


#line 1867 "gt_overlay_yac.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 581 "gt_overlay_yac.y"



/**********************************************************************
 * $Log: gt_overlay_yac.y,v $
 * Revision 1.1.1.1  2008/07/14 16:44:22  endo
 * MAST Project (based on MissionLab-MINOS-20071018.tar.gz)
 *
 * Revision 1.7  2007/08/10 04:41:06  pulam
 * Added scale fix and military unit drawing fix.
 *
 * Revision 1.6  2007/03/12 06:04:07  nadeem
 * Modified code to remove the overloading and hence notational abuse of MISSION-AREA statement in the .ovl file
 *
 * Revision 1.5  2007/03/12 00:06:33  nadeem
 * Fixed code so that the mission area is expressed in meters internally for simulations.
 *
 * Revision 1.4  2007/03/06 05:06:52  nadeem
 * Modified code to use Mercator projection to map between lat/lon and X/Y positions.
 *
 * Revision 1.3  2006/09/26 18:33:50  endo
 * ICARUS Wizard integrated with Lat/Lon.
 *
 * Revision 1.2  2006/09/20 18:34:48  nadeem
 * Added the code to convert latitude/longitude to X/Y and vice-versa. A lot of files had to be touched to make sure that the initialisation values can flow across from mlab to the robot executables as well as to ensure that the functions were available for use on both sides of the code.
 *
 * Revision 1.1.1.1  2006/07/20 17:17:50  endo
 * MINOS Project (based on MissionLab-7.0.20060712.tar.gz)
 *
 * Revision 1.1.1.1  2006/07/12 13:37:59  endo
 * MissionLab 7.0
 *
 * Revision 1.6  2006/07/11 10:07:49  endo
 * CMDLi Panel merged from MARS 2020.
 *
 * Revision 1.5  2005/07/23 05:58:20  endo
 * 3D visualization improved.
 *
 * Revision 1.4  2005/05/18 21:01:55  endo
 * Conflicts by previous mod resolved.
 *
 * Revision 1.3  2005/04/22 23:01:45  endo
 * Heightmap now accepts '*.*' as its name.
 *
 * Revision 1.2  2005/03/23 07:36:55  pulam
 * *** empty log message ***
 *
 * Revision 1.1.1.1  2005/02/06 23:00:10  endo
 * AO-FNC Project (based on mlab-6.0.01.06192003.tar.gz)
 *
 * Revision 1.36  2000/07/07 18:16:52  endo
 * waypoint_file_statement added.
 *
 * Revision 1.35  2000/04/25 09:43:22  jdiaz
 * *** empty log message ***
 *
 * Revision 1.34  2000/02/07 05:14:26  jdiaz
 * doorways walls hallways rooms
 *
 * Revision 1.33  1999/08/31 15:12:39  endo
 * *** empty log message ***
 *
 * Revision 1.32  1999/08/30 21:33:53  jdiaz
 * add utm_coordinate rules for UTM translations
 *
 * Revision 1.31  1997/02/14 15:49:30  zchen
 * *** empty log message ***
 *
 * Revision 1.30  1996/02/16  00:06:44  doug
 * *** empty log message ***
 *
 * Revision 1.29  1996/02/08  19:24:07  doug
 * handle objects of any color
 *
 * Revision 1.28  1995/11/07  14:31:57  doug
 * added baskets and command to drop oranges into them
 *
 * Revision 1.27  1995/10/03  21:25:06  doug
 * add support for get_objects call
 *
 * Revision 1.26  1995/10/03  15:48:58  doug
 * attractor support added to control diameter
 *
 * Revision 1.25  1995/10/03  15:44:00  doug
 * added attractor statement
 *
 * Revision 1.24  1995/06/12  16:17:39  jmc
 * Added load_map_statement.
 *
 * Revision 1.23  1995/05/08  17:47:33  jmc
 * Changed old reference to mpp to zoom_factor.
 *
 * Revision 1.22  1995/05/06  00:43:28  jmc
 * Changed the grammar for SET METERS-PER-PIXEL to SET ZOOM-FACTOR.
 *
 * Revision 1.21  1995/05/04  22:05:11  jmc
 * Added include for gt_scale.h since all the scale related functions
 * moved to it.
 *
 * Revision 1.20  1995/05/02  21:21:16  jmc
 * Added grammar for SET METERS-PER-PIXEL statement.
 *
 * Revision 1.19  1995/05/02  19:49:49  jmc
 * Changed WORK-AREA to MISSION-AREA.
 *
 * Revision 1.18  1995/05/02  18:56:06  jmc
 * Added grammar for WORK-AREA statement.
 *
 * Revision 1.17  1995/04/20  18:18:31  jmc
 * Corrected spelling.
 *
 * Revision 1.16  1995/04/19  22:20:18  jmc
 * Added a fprintf(stderr, ...) message for running out of memory
 * since it may not be possible to pop up the warn_user interface at
 * that point.
 *
 * Revision 1.15  1995/04/14  21:25:52  jmc
 * Removed the defaults for the diameter/width of some control
 * measures (put those defaults in gt_console_db.c).  The gt_add_*
 * functions in gt_console_db.c know to use the default values by the
 * negative values specified in this file.
 *
 * Revision 1.14  1995/04/05  21:14:47  jmc
 * Added grammar for starting point.
 *
 * Revision 1.13  1995/04/05  20:36:15  jmc
 * Converted OBSTACLE rule to coordinate_pair (from NUMBER NUMBER) to
 * make it consistent with all the other rules.
 *
 * Revision 1.12  1995/04/04  20:54:03  jmc
 * Cosmetic changes: Reindented the statement rules to narrow them.
 * Alphabetized the statement rules.
 *
 * Revision 1.11  1995/04/03  20:28:05  jmc
 * Added copyright notice.
 *
 * Revision 1.10  1994/11/07  20:11:33  jmc
 * Small mods to make sure that everything uses the origin correctly.
 *
 * Revision 1.9  1994/11/07  19:56:13  jmc
 * Changed origin_x and origin_y to use globals now defined in
 * gt_world.c.
 *
 * Revision 1.8  1994/11/07  17:23:20  jmc
 * Implemented the grammar to add obstacles (OBSTACLE x y r).
 *
 * Revision 1.7  1994/10/25  20:23:23  jmc
 * Added syntax to optionally allow specifying the diameter of
 * passage points, attack positions, battle positions, and
 * objectives.
 *
 * Revision 1.6  1994/08/18  19:28:12  doug
 * Converted SUCCESS/FAILURE to GT_SUCCESS/GT_FAILURE
 *
 * Revision 1.5  1994/08/04  18:37:10  jmc
 * Added grammar for optional width on axis_statement and
 * gap_statement.
 *
 * Revision 1.4  1994/08/03  16:57:35  jmc
 * Added error trapping for errors in add_* functions calls using the
 * odl_error function and YYABORT.
 *
 * Revision 1.3  1994/07/12  19:22:27  jmc
 * Tweaked RCS automatic identification strings
 *
 * Revision 1.2  1994/07/12  17:34:45  jmc
 * Added RCS automatic identification strings
 **********************************************************************/
